#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
using namespace std;
long int nzd(long int a, long int b)
{
  if (b) return nzd(b, a%b);
  return a;
}
int main()
{
  int n;
  cin >> n;
  vector<bool>X(n);
  long int nzdA;
  for (int t=0; t<n; t++)
  {
    long int n1,n2;
    cin >> n1 >> n2;
    long int x, y, prviA;
    for (int i=0; i<n1; i++)
    {
      cin >> x;
      if (i==0) prviA=x;
      if (i==1) nzdA=abs(x-prviA);
      else nzdA=nzd(abs(x-prviA),nzdA);
    }
    X[t]=true;
    for (int j=0; j<n2; j++)
    {
      cin >> y;
      if ((y-prviA)%nzdA==0)
      {
        X[t]=false;
        break;
      }
    }
  }
  for (int i=0; i<n; i++)
  {
    cout << X[i] << endl;
  }
  return 0;
}